/*
 * PM - Line follower
 * 
 */

#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>


void ADC_init(void)
{
	ADMUX = 0;
	ADMUX = (1 << REFS0);  // tens de alimentare
	
	ADCSRA = (1 << ADEN) | (7 << ADPS0); //enable the ADC;
}


int ADC_get(uint8_t channel)
{

	ADMUX &= ~(0b00011111 << MUX0); 
	ADMUX |= channel; 

		
	ADCSRA |= (1 << ADSC);	//start conversion
	while(ADCSRA & (1 << ADSC));	//wait for conversion to finish

	return ADC;
}

void pwm_init(void)
{
	//fast pwm cu top la icr1; non inverting;
	TCCR1A |= (1 << WGM11) | (1 << COM1A1) | (1 << COM1B1);
	TCCR1B |= (1 << WGM13) | (1 << WGM12) | (1 << CS12);
	
	ICR1 = 1024;
	
	OCR1A = 800;
	OCR1B = 800;
}


int main(void)
{
	/* Initializari */
	
	ADC_init();
	pwm_init();
	
	DDRA = 0;
	PORTA = 255;
	DDRD = (1 << PD7) | (1 << PD4) | (1 << PD5); 
	PORTD |= (1 << PD4) | (1 << PD5);
	
	DDRC = (15 << PC0);
	PORTC = (1 << PC0) | (1 << PC3);
	PORTD = 0;

	/* 
	
	PC0 - inainte roata stanga
	PC1 - inapoi roata stanga
	PC2 - inapoi roata dreapta
	PC3 - inainte roata dreapta
	
	730 - senzorul detecteaza banda neagra (cu firul de la vcc placa la 5v driver!)
	810 - sezorul detecteaza banda (doar cu bateriile)
	
	*/
	
	OCR1A = 0;
	OCR1B = 0;
	_delay_ms(5000);
	
	int i, right, left, onLine, last = 2;
	
	/* 
	* last = 1 -> right
	* last = 0 -> left
	*/
		
	while (1) {
		
		right = 0;
		left = 0;
		onLine = 0;
		
		for (i = 0; i < 4; i++){
			right += ADC_get(i);
			//do 800!
	//		if (ADC_get(i) > 800)
	//			onLine = 1;
		}
			
		for (i = 4; i < 8; i++){
			left += ADC_get(i);
	//		if (ADC_get(i) > 800)
	//			onLine = 1;
			
		}
			
	//	if (onLine == 0){
	//		OCR1A = 0;
	//		OCR1B = 0;
	//		PORTD |= (1 << PD7);

	//	}
	//	else {
		//	PORTD &= ~(1 << PD7);
		
			if (left > right){
				//go left
				OCR1A = 100;
				OCR1B = 500;
				last = 0;
			}
			
			if (left < right){
				//go right
				OCR1A = 500;
				OCR1B = 100;
				last = 1;
			}
			if (left == right){
		//		OCR1A = 400;
		//		OCR1B = 400;
				if (last == 1){
					//go right
					OCR1A = 500;
					OCR1B = 100;
					last = 1;
				}
				else {
					//go left
					OCR1A = 100;
					OCR1B = 500;
					last = 0;
				}
			}
	//	}
		
			
	}
	return 0;
}
